:: send_ebnaut_ublox (DF6NM 2021-03-23)
:: allows fractional frequencies (21-05-14)
:: fixed for hour without leading zero, fixed shorter last symbol (21-05-14)

:: the ebnaut sequence should be in pskln.txt, generated by "Save Rows" in ebnaut-tx software
:: raster (seconds): transmission starts at multiples of this time interval
::  (will work across midnight, but not into a new month) 
::  (local format of %date% should start with DD. For MM-DD-YYYY, change %t1:~12,2% to %t1:~15,2%) 
:: maxlate (seconds): transmission can be started late, shortly after nominal sequence start time
:: repeats: number of sequences to be sent
:: sym (seconds): symbol duration
:: freq (Hz): tx frequency, should be integer or close to integer Hz, e.g. 8270.0025
:: comport: serial port of GPS device
:: timepulse: select either 0, or 1 (if the GPS device has two clock output pins)

@set raster=3600
@set maxlate=120
@set repeats=2
@set sym=10
@set freq=8270.0025
@set comport=com3
@set timepulse=1
@set psklnfile=pskln.txt

@set tp= 
@if %timepulse% neq 1 set tp= tp

:loop
@if %repeats% leq 0 goto :eof
@set t1=%time% %date%
@echo   %t1%, %repeats% sequences to do
@set /a t2=(1%t1:~12,2%-100)*86400+%t1:~0,2%*3600+(1%t1:~3,2%-100)*60+1%t1:~6,2%-100
@set /a st=t2-maxlate
@set /a st=(st/raster+1)*raster
@set cnt=0
@set /a stn=st-1
@set /a dt=stn-t2
@if %dt% gtr 0 timeout %dt% /nobreak >nul
@set freqn=0
@for /f %%i in (%psklnfile%) do @call :doline %%i
@set /a dt=sym+1
:l4
@setubx2 %freqn%%tp% >%comport%
::@echo %cnt% %dt% %time% %bitn% %freqn%
@timeout 1 /nobreak >nul
@set /a dt=dt-1
@if %dt% gtr 0 goto l4
@setubx2 0%tp% >%comport%
@set /a repeats=repeats-1
@goto :loop

:doline
@set t1=%time% %date%
@set /a t2=(1%t1:~12,2%-100)*86400+%t1:~0,2%*3600+(1%t1:~3,2%-100)*60+1%t1:~6,2%-100
@set /a dt=stn-t2
@if %dt% leq 0 goto l3
:l2
@setubx2 %freqn%%tp% >%comport%
::@echo %cnt% %dt% %time% %1 %freqn%
@timeout 1 /nobreak >nul
@set /a dt=dt-1
@if %dt% gtr 0 goto l2
:l3
@set bitn=%1
@set freqn=%freq% & if %1 equ 0 set freqn=-%freq%
@echo %cnt% %time% %bitn%
@set /a cnt=cnt+1
@set /a stn=sym*cnt+st-1
